#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2048;
int n, dp[maxn], used[maxn], p[maxn], num[maxn];

struct edge{
    int x, cost;
};

vector<edge> v[maxn], g[maxn];

void build(int ver){
    used[ver] = 1;
    for(edge nb : v[ver]){
        if(!used[nb.x]){
            g[ver].push_back(nb);
            p[nb.x] = ver;
            num[nb.x] = g[ver].size() - 1;
            build(nb.x);
        }
    }
}


void read(){
    cin >> n;
    for(int i = 1;i <= n - 1;i++){
        int x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        v[y].push_back({x, w});
    }
    build(1);
}

void calc(int ver){
    for(edge nb : g[ver]){
        dp[nb.x] += dp[ver] + nb.cost;
        calc(nb.x);

    }
}

void recreate(int ver){
    if(ver == 1)
        return;
    recreate(p[ver]);
    g[p[ver]][num[ver]].cost = 0;
    dp[ver] += dp[p[ver]] + g[p[ver]][num[ver]].cost;

}

void solve(){
    int Irma = 0, Alex = 0, odd = 1;
    while(1){
        calc(1);
        int curr = 1;
        for(int i = 1;i <= n;i++){
            if(dp[curr] < dp[i])
                curr = i;
        }
        if(dp[curr] == 0)
            break;
        if(odd == 1)
            Irma += dp[curr];
        else
            Alex += dp[curr];
        for(int i = 1;i <= n;i++)
            dp[i] = 0;
        recreate(curr);
        odd = 1 - odd;
    }
    if(Irma > Alex)
        cout << "Irma " << Irma << endl;
    else if(Irma < Alex)
        cout << "Alex " << Alex << endl;
    else
        cout << "Draw\n";
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
