#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

int n,m,a[MAXN],b[MAXN],li[MAXN],tim,k,dsu[MAXN],comp[MAXN];
long long s[MAXN];
stack<int> st;
vector<int> v[MAXN],r[MAXN];

void dfs(int x){
    li[x]=tim;
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i]]==tim)continue;
        dfs(v[x][i]);
    }
    st.push(x);
}

int root(int x){
    if(dsu[x]==x)return x;
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void mergev(int x,int y){
    if(root(x)==root(y))return;
    s[root(y)]+=s[root(x)];
    dsu[root(x)]=root(y);
}

void scc(int x,int z){
    mergev(x,z);
    li[x]=tim; comp[x]=k;
    for(int i=0;i<r[x].size();i++){
        if(li[r[x][i]]==tim)continue;
        scc(r[x][i],z);
    }
}

int main(){
    
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        dsu[i]=i;
    }

    for(int i=1;i<=m;i++){
        cin>>a[i]>>b[i];
    }

    for(int test=1;test<=3;test++){
        for(int f=1;f<=m;f++){
            if(s[root(a[f])]>=s[root(b[f])]){
                v[a[f]].push_back(b[f]);
                r[b[f]].push_back(a[f]);
            }

            if(s[root(a[f])]<=s[root(b[f])]){
                v[b[f]].push_back(a[f]);
                r[a[f]].push_back(b[f]);
            }
        }

        tim++;
        for(int f=1;f<=n;f++){
            if(li[f]!=tim)dfs(f);
        }

        tim++; k=0;
        while(!st.empty()){
            if(li[st.top()]!=tim){
                k++; scc(st.top(),st.top());
            }
            st.pop();
        }
    }

    for(int i=1;i<=n;i++){
        if(comp[i]==1)cout<<"1";
        else cout<<"0";
    }
    cout<<"\n";

    return 0;
}


