#include <bits/stdc++.h>

using namespace std;

const int maxn = 20;
const int mod = 1000003;

int n, k;
string s[maxn];

bool bf[maxn];
long long ans = 0;

int coeff[maxn];

void f(int pos)
{
    if (pos == n + 1)
    {
        int cnt = 0;
        int expected_size = 0;
        bool ok = true;

        for (int i = 1; i <= n; ++i)
        {
            if (bf[i] == true)
            {
                cnt += coeff[i];
                cnt %= mod;
                if (cnt == coeff[i])
                {
                    expected_size = s[i].size();
                }
                else if (expected_size != s[i].size())
                {
                    ok = false;
                    break;
                }
            }
        }

        if (ok == false || cnt != k)
        {
            return;
        }

        long long res = 1;

        for (int i = 0; i < expected_size; ++i)
        {
            char letter = '?';
            bool ok = true;

            for (int j = 1; j <= n; ++j)
            {
                if (bf[j] == true && s[j][i] != '?')
                {
                    if (letter == '?')
                    {
                        letter = s[j][i];
                    }
                    else if (letter != s[j][i])
                    {
                        ok = false;
                        break;
                    }
                }
            }

            if (ok == false)
            {
                return;
            }

            if (letter != '?')
            {
                continue;
            }

            res *= 26;
            res %= mod;
        }

        ans += res;
        ans %= mod;

        return;
    }

    for (int i = 0; i <= 1; ++i)
    {
        bf[pos] = i;
        f(pos + 1);
    }
}

int index_in_result[maxn];

void compress()
{
    vector<string> result;

    for (int i = 1; i <= n; ++i)
    {
        coeff[i] = 1;
    }

    for (int i = 1; i <= n; ++i)
    {
        bool need = true;

        for (int j = 1; j <= n; ++j)
        {
            if (i == j || s[i].size() != s[j].size())
            {
                continue;
            }

            bool is_spanned = true;

            for (int k = 0; k < s[i].size(); ++k)
            {
                if (s[i][k] != '?' && s[j][k] != '?')
                {
                    if (s[i][k] != s[j][k])
                    {
                        is_spanned = false;
                        break;
                    }
                }
                else if (s[i][k] != '?' && s[j][k] == '?')
                {
                    is_spanned = true;
                }
                else if (s[i][k] == '?' && s[j][k] != '?')
                {
                    is_spanned = false;
                    break;
                }
            }

            if (is_spanned == true)
            {
                ++coeff[index_in_result[j]];
                need = false;
                break;
            }
        }

        if (need == true)
        {
            index_in_result[i] = result.size() + 1;
            result.push_back(s[i]);
        }
    }

    n = result.size();

    for (int i = 1; i <= n; ++i)
    {
        s[i] = result[i - 1];
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }

    compress();

    f(1);

    cout << ans << endl;

    return 0;
}

/*
3 1
aa
a?
b?
*/
