#include <bits/stdc++.h>

using namespace std;

const int maxn = 20;
const int mod = 1000003;

int n, k;
string s[maxn];

bool bf[maxn];
long long ans = 0;

map<string, int> coeff;

void f(int pos)
{
    if (pos == n + 1)
    {
        int cnt = 0;
        int expected_size = 0;
        bool ok = true;

        for (int i = 1; i <= n; ++i)
        {
            if (bf[i] == true)
            {
                cnt += coeff[s[i]];

                if (cnt == coeff[s[i]])
                {
                    expected_size = s[i].size();
                }
                else if (expected_size != s[i].size())
                {
                    ok = false;
                    break;
                }
            }
        }

        if (ok == false || cnt != k)
        {
            return;
        }

        long long res = 1;

        for (int i = 0; i < expected_size; ++i)
        {
            char letter = '?';
            bool ok = true;

            for (int j = 1; j <= n; ++j)
            {
                if (bf[j] == true && s[j][i] != '?')
                {
                    if (letter == '?')
                    {
                        letter = s[j][i];
                    }
                    else if (letter != s[j][i])
                    {
                        ok = false;
                        break;
                    }
                }
            }

            if (ok == false)
            {
                return;
            }

            if (letter != '?')
            {
                continue;
            }

            res *= 26;
            res %= mod;
        }

        ans += res;
        ans %= mod;

        return;
    }

    for (int i = 0; i <= 1; ++i)
    {
        bf[pos] = i;
        f(pos + 1);
    }
}

char let[maxn];
int slow_ans = 0;

void slow(int pos, int to)
{
    if (pos == to + 1)
    {
        string curr = "";

        for (int i = 1; i <= to; ++i)
        {
            curr.push_back(let[i]);
        }

        int cnt = 0;

        for (int i = 1; i <= n; ++i)
        {
            if (curr.size() == s[i].size())
            {
                bool ok = true;

                for (int j = 0; j < curr.size(); ++j)
                {
                    if (curr[j] != s[i][j] && s[i][j] != '?')
                    {
                        ok = false;
                        break;
                    }
                }

                if (ok == true)
                {
                    ++cnt;
                }
            }
        }

        if (cnt == k)
        {
            ++slow_ans;
        }

        return;
    }

    for (char c = 'a'; c <= 'z'; ++c)
    {
        let[pos] = c;
        slow(pos + 1, to);
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;
    set<int> sizes;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
        sizes.insert(s[i].size());
    }

    if (n >= 11)
    {
        f(1);
        cout << ans << endl;
        return 0;
    }

    for (auto sz : sizes)
    {
        slow(1, sz);
    }

    cout << slow_ans << endl;

    return 0;
}

/*
3 1
aa
a?
b?

3 3
??
??
??
*/
