#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const long long maxn = 1e3 + 1;
long long n, a[maxn], dp[maxn][maxn];

void read(){
    cin >> n;
    for(long long i = 1;i <= n;i++)
        cin >> a[i];
}

void solve(){
    long long ans = 0;
    long long l = 1, r = n;
    while(l <= r){
        long long s1 = a[l], s2 = a[r];
        l++, r--;
        for(;;){
            while(s1 < s2){
                s1 += a[l];
                ans++;
                l++;
            }
            while(l <= r && s1 > s2){
                s2 += a[r];
                ans++;
                r--;
            }
            if(s1 == s2){
                if(l - 1 == r + 1){
                    cout << n - 1 << endl;
                    return;
                }
                break;
            }
        }
    }
    cout << ans << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    solve();
    return 0;
}
