#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 16;
const int mod = 1e6 + 3;
int n, k;
string s[maxn];
vector<string> v;
map<string, int> m;


void read(){
    cin >> n >> k;
    for(int i = 1;i <= n;i++)
        cin >> s[i];

}

long long ans = 0;

void check(vector<int> idx){
    for(int i = 1;i < idx.size();i++){
        if(s[idx[i]].size() != s[idx[i - 1]].size())
            return;
    }
    int len = s[idx[0]].size();
    long long curr = 1;
    string t = "";
    for(int i = 0;i < len;i++){
        int br = 0;
        char c = '?';
        for(int j = 0;j < idx.size();j++){
            if(s[idx[j]][i] != '?'){

                if(br && c != s[idx[j]][i])
                    br++;
                if(!br)
                    br++;
                c = s[idx[j]][i];
            }
        }
        if(br > 1)
            return;
        if(br == 0)
            curr = (curr * 26) % mod;
        t += c;
    }
    v.push_back(t);
    ans = (ans + curr) % mod;
}

void rec(int pos, int cnt, vector<int> num){
    if(cnt == k){
        check(num);
        return;
    }
    if(pos > n)
        return;
    rec(pos + 1, cnt, num);
    num.push_back(pos);
    rec(pos + 1, cnt + 1, num);
    num.pop_back();
}

bool cmp(string a, string b){
    if(a.size() != b.size())
        return a.size() < b.size();
    return a < b;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    rec(1, 0, {});
    sort(v.begin(), v.end(), cmp);
    for(int i = 0;i < v.size();i++){
        for(int j = i + 1;j < v.size();j++){
            m[v[j]]++;
            if(m[v[j]] > 1)
                continue;
            int br = 0;
            if(v[i].size() != v[j].size())
                continue;
            int sz = v[i].size();
            bool flag = true;
            long long curr = 1;
            for(int k = 0;k < sz;k++){
                if(v[i][k] != '?' && v[j][k] != '?' && v[i][k] != v[j][k]){
                    flag = false;
                    break;
                }
                if(v[i][k] == '?' && v[j][k] == '?'){
                    curr = (curr * 26) % mod;
                }
            }
            if(flag)
                ans = (ans  - curr) % mod;
        }
        m.clear();
    }
    cout << ans << endl;
    return 0;
}
