#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 10;
int n, r, q, a[maxn][maxn], b[maxn], c[maxn], arr[maxn];

void print(){
    for(int i = 1;i <= n;i++){
        for(int  j = 1;j <= n;j++)
            cout << a[i][j] << ' ';
        cout << endl;
    }
}
void update_row(int r, int k){
    if(k < 0){
        while(k < 0)
            k += n;
    }
    k %= n;
    for(int i = 1;i <= n;i++)
        b[i] = a[r][i];
    int pos = 1;
    for(int i = n - k + 1;i <= n;i++)
        c[pos++] = b[i];
    for(int i = 1;i <= n - k;i++)
        c[pos++] = b[i];
    for(int i = 1;i <= n;i++)
        a[r][i] = c[i];
}

void update_col(int col, int k){
    if(k < 0){
        while(k < 0)
            k += n;
    }
    k %= n;
    for(int i = 1;i <= n;i++)
        b[i] = a[i][col];
    int pos = 1;
    for(int i = n - k + 1;i <= n;i++)
        c[pos++] = b[i];
    for(int i = 1;i <= n - k;i++)
        c[pos++] = b[i];
    for(int i = 1;i <= n;i++)
        a[i][col] = c[i];
}

void update_diag(int r, int c, int k){

    int e = min(r, c);
    r -= e; r++;
    c -= e; c++;
    int length = n - max(r, c) + 1;

    if(k < 0){
        while(k < 0)
            k += length;
    }
    k %= length;
    int pos = 1;
    int rr = r, cc = c;
    while(rr <= n && cc <= n){
        arr[pos] = a[rr][cc];
        rr++, cc++;
        pos++;
    }
    pos = 1;
    for(int i = length - k + 1;i <= length;i++)
        b[pos++] = arr[i];
    for(int i = 1;i <= length - k;i++)
        b[pos++] = arr[i];
    rr = r, cc = c, pos = 1;
    while(rr <= n && cc <= n){
        a[rr][cc] = b[pos];
        rr++, cc++, pos++;
    }
}

void update_opak(int r, int c, int k){
    int p = min(r, c);
    r -= p; r++;
    c -= p;
    c = n - c;
    int length = n - min(r, c) + 1;
    if(k < 0){
        while(k < 0)
            k += length;
    }
    k %= length;
    int rr = r, cc = c, pos = 1;
    while(rr <= n && cc >= 1){
        arr[pos] = a[rr][cc];
        rr++, cc--;
        pos++;
    }
    pos = 1;
    for(int i = length - k + 1;i <= length;i++)
        b[pos++] = arr[i];
    for(int i = 1;i <= length - k;i++)
        b[pos++] = arr[i];
    rr = r, cc = c, pos = 1;
    while(rr <= n && cc >= 1){
        a[rr][cc] = b[pos];
        rr++, cc--;
        pos++;
    }
}

void read(){
    cin >> n >> r;
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            a[i][j] = n * (i - 1) + j;
        }
    }
    while(r--){
        char c;
        cin >> c;
        if(c == 'r'){
            int row, k;
            cin >> row >> k;
            update_row(row + 1, k);
        }
        else if(c == 'c'){
            int col, k;
            cin >> col >> k;
            update_col(col + 1, k);
        }
        else if(c == 'd'){
            int r, c, k;
            cin >> r >> c >> k;
            update_diag(r + 1, c + 1, k);
        }
        else{
            int r, c, k;
            cin >> r >> c >> k;
            update_opak(r + 1, c + 1, k);
        }


    }
    cin >> q;
    while(q--){
        int r, c;
        cin >> r >> c;
        cout << a[r + 1][c + 1] << endl;
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    read();
    return 0;
}
