#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
};

const int maxn = 2005;

int n;
int sub[maxn],used[maxn];
int par[maxn],st[maxn];
vector<edge>g[maxn];
vector<int>ans;
vector<int>lv;
int z;

void read()
{
    cin >> n;
    int x,y,d;
    for(int i=1;i<n;i++)
    {
        cin >> x >> y >> d;
        g[x].push_back({y,d});
        g[y].push_back({x,d});
    }
}

void dfs_sub(int beg, int pa, int nz)
{
    par[beg] = pa;
    st[beg] = nz;
    int br = 0;
    for(edge nb:g[beg])
    {
        if(nb.ver!=pa)
        {
            br++;
            dfs_sub(nb.ver,beg,nb.dist);
            sub[beg] += sub[nb.ver];
        }
    }
    if(br==0) lv.push_back(beg);
    sub[beg]++;
}

void find_path(int beg)
{
    if(par[beg]==beg) return;
    z += st[beg];
    find_path(par[beg]);
}

void make_0(int beg)
{
    if(par[beg]==beg) return;
    st[beg] = 0;
    make_0(par[beg]);
}

void solve()
{
    lv.push_back(0);
    dfs_sub(1,1,0);
    int sz = lv.size();
    int ch1 = 0;
    int ch2 = 0;
    for(int q=1;q<=sz;q++) ///   Q<=SZ
    {
        //cout << "++++++++++" << endl;
        int idx = 0;
        for(int i=1;i<sz;i++)
        {
            z = 0;
            find_path(lv[i]);
            //cout << z << endl;
            used[i] = z;
            if(used[i]>used[idx]) idx = i;
        }
        make_0(lv[idx]);
        if(q%2) ch1 += used[idx];
        else ch2 += used[idx];
    }
    if(ch1>ch2) cout << "Irma " << ch1 << endl;
    else if(ch1<ch2) cout << "Alex " << ch2 << endl;
    else cout << "Draw" << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
	solve();
return 0;
}
