#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 1024;

int n,r,q;
int a[maxn][maxn];
char type;
int x,y,d;

void change_d(int len)
{
    if(d>=0)
    {
        d %= len;
        return;
    }
    int times = 0;
    int ch = abs(d);
    times = ch/len;
    if(ch%len) times++;
    d += (times*len);
    d %= len;
}

void solve1()
{
    vector<int>pom;
    for(int j=1;j<=n;j++) pom.push_back(a[x][j]);
    change_d(pom.size());
    int idx = pom.size()-d;
    vector<int>nz;
    for(int i=idx;i<pom.size();i++) nz.push_back(pom[i]);
    for(int i=0;i<idx;i++) nz.push_back(pom[i]);
    for(int j=1;j<=n;j++) a[x][j] = nz[j-1];
}

void solve2()
{
    vector<int>pom;
    for(int i=1;i<=n;i++) pom.push_back(a[i][x]);
    change_d(pom.size());
    int idx = pom.size()-d;
    vector<int>nz;
    for(int i=idx;i<pom.size();i++) nz.push_back(pom[i]);
    for(int i=0;i<idx;i++) nz.push_back(pom[i]);
    for(int i=1;i<=n;i++) a[i][x] = nz[i-1];
}

void solve3()
{
    vector<int>pom;
    while(x>1&&y>1)
    {
        x--;
        y--;
    }
    int p1 = x;
    int p2 = y;
    while(p1<=n&&p2<=n)
    {
        pom.push_back(a[p1][p2]);
        p1++;
        p2++;
    }
    change_d(pom.size());
    int idx = pom.size()-d;
    vector<int>nz;
    for(int i=idx;i<pom.size();i++) nz.push_back(pom[i]);
    for(int i=0;i<idx;i++) nz.push_back(pom[i]);
    p1 = x;
    p2 = y;
    idx = 0;
    while(p1<=n&&p2<=n)
    {
        a[p1][p2] = nz[idx];
        idx++;
        p1++;
        p2++;
    }
}

void solve4()
{
    vector<int>pom;
    while(x>1&&y<n)
    {
        x--;
        y++;
    }
    int p1 = x;
    int p2 = y;
    while(p1<=n&&p2>=1)
    {
        pom.push_back(a[p1][p2]);
        p1++;
        p2--;
    }
    change_d(pom.size());
    int idx = pom.size()-d;
    vector<int>nz;
    for(int i=idx;i<pom.size();i++) nz.push_back(pom[i]);
    for(int i=0;i<idx;i++) nz.push_back(pom[i]);
    p1 = x;
    p2 = y;
    idx = 0;
    while(p1<=n&&p2>=1)
    {
        a[p1][p2] = nz[idx];
        idx++;
        p1++;
        p2--;
    }
}

void read()
{
    cin >> n;
    int idx = 0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            idx++;
            a[i][j] = idx;
        }
    }
    cin >> r;
    for(int i=1;i<=r;i++)
    {
        cin >> type;
        if(type=='r'||type=='c')
        {
            cin >> x >> d;
            x++;
            if(type=='r') solve1();
            else solve2();
        }
        else
        {
            cin >> x >> y >> d;
            x++;
            y++;
            if(type=='d') solve3();
            else solve4();
        }
    }
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        cin >> x >> y;
        x++;
        y++;
        cout << a[x][y] << endl;
    }
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
return 0;
}
