#include<bits/stdc++.h>
#define MAXN 1007
using namespace std;

int n,r,q;
int s,k,z,w;

int t[MAXN][MAXN],temp[MAXN];
vector<int> v;
char type;

void shiftrow(int s,int k){
    for(int i=0;i<n;i++){
        temp[i]=t[s][(i+k+1000*n)%n];
    }
    for(int i=0;i<n;i++){
        t[s][i]=temp[i];
    }
}

void shiftcol(int s,int k){
    for(int i=0;i<n;i++){
        temp[i]=t[(i+k+1000*n)%n][s];
    }
    for(int i=0;i<n;i++){
        t[i][s]=temp[i];
    }
}

void shiftdiag(int s,int k){
    v.clear();
    for(int i=0;i<n;i++){
        if(i+s>=0 and i+s<n){
            v.push_back(t[i][i+s]);
        }
    }
    for(int i=0;i<v.size();i++){
        temp[i]=v[(i+k+1000*int(v.size()))%int(v.size())];
    }
    for(int i=0;i<v.size();i++){
        v[i]=temp[i];
    }
    for(int i=n-1;i>=0;i--){
        if(i+s>=0 and i+s<n){
            t[i][i+s]=v.back();
            v.pop_back();
        }
    }
}

void shiftdiag2(int s,int k){
    v.clear();
    for(int i=0;i<n;i++){
        if(s-i>=0 and s-i<n){
            v.push_back(t[i][s-i]);
        }
    }
    for(int i=0;i<v.size();i++){
        temp[i]=v[(i+k+1000*int(v.size()))%int(v.size())];
    }
    for(int i=0;i<v.size();i++){
        v[i]=temp[i];
    }
    for(int i=n-1;i>=0;i--){
        if(s-i>=0 and s-i<n){
            t[i][s-i]=v.back();
            v.pop_back();
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>r;

    for(int i=0;i<n;i++){
        for(int f=0;f<n;f++){
            t[i][f]=i*n+f+1;
        }
    }

    for(int i=1;i<=r;i++){
        cin>>type;
        if(type=='r'){
            cin>>s>>k;
            shiftrow(s,-k);
        }else if(type=='c'){
            cin>>s>>k;
            shiftcol(s,-k);
        }else if(type=='d'){
            cin>>s>>w>>k;
            shiftdiag(w-s,-k);
        }else if(type=='x'){
            cin>>s>>w>>k;
            shiftdiag2(s+w,-k);
        }
    }

    cin>>q;
    for(int i=0;i<q;i++){
        cin>>s>>w;
        cout<<t[s][w]<<"\n";
    }

    return 0;
}
