#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;

llong n, d;
void solve()
{
    assert(0 <= n && n <= 1000000);
    assert(0 <= d && d <= 18);
    
    if ((n % (1LL << d)) == 0)
    {
        std::cout << "YES\n";
    } else
    {
        std::cout << "NO\n";
    }
}

void input()
{
    std::cin >> n >> d;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}