#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;

inline llong operator % (const std::vector <llong>& a, const int &num)
{
    llong prenos = 0;
    for (int i = a.size() - 1 ; i >= 0 ; --i)
    {
        prenos *= 10;
        prenos += a[i];
        prenos %= num;
    }

    return prenos;
}

int d;
std::string n;
std::vector <llong> num;
void solve()
{
    std::reverse(n.begin(), n.end());
    for (const char &c : n)
    {
        num.push_back(c - '0');
    }

    if (num.empty())
    {
        num.push_back(0);
    }

    d = (1 << d);
    if ((num % d) == 0)
    {
        std::cout << "YES\n";
    } else
    {
        std::cout << "NO\n";
    }
}

void input()
{
    std::cin >> n >> d;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}