#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, k;
int a[MAXN];

void solve()
{
    int ans = 0;
    int lPtr = 1;
    std::sort(a + 1, a + 1 + n);
    for (int rPtr = 1 ; rPtr <= n ; ++rPtr)
    {
        while (a[rPtr] - a[lPtr] > k)
        {
            lPtr++;
        }

        ans = std::max(ans, rPtr - lPtr + 1);
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}